let find_sample = 
  let samples = Hashtbl.create 10 in
    fun name ->
      try Hashtbl.find samples name 
      with Not_found ->
	let filename path = path ^ "/" ^ name ^ ".wav" in
	let s = 
	  GobaUtils.find_some
	    (fun path ->
	       try 
		 let file = filename path in
		 if try Unix.access file [Unix.R_OK]; true with Unix.Unix_error _ -> false then
		   Some (Sdlmixer.loadWAV file)
		 else
		   None
	       with Sdlmixer.SDLmixer_exception _ -> None)
	    Config.sfx_paths
	in
	  Hashtbl.add samples name s;
	  s

class channel (Sfx.Channel n) : Sfx.channel =
object
  method playing = Sdlmixer.playing_channel n
  method expire t = Sdlmixer.expire_channel n t
  method play ?loops (Sfx.Sample name) = Sdlmixer.play_channel ?loops ~channel:n (find_sample name)
  method release = ()
end
