(* a module for reading tar-archives. it memory maps the archive at initialization. *)

type contents = (char, Bigarray.int8_unsigned_elt, Bigarray.c_layout) Bigarray.Array1.t

type t

val open_archive : string -> t

(* locate a file and read its contents; raise Not_found if no such entry *)
val find : t -> string -> contents

(* list archive contents *)
val contents : t -> string list

(* convert the blob of memory into a string *)
val string_of_contents : contents -> string
